/*
 * SourceMod Radio
 *
 * Adds a radio player to SourceMod that supports direct station links or streaming audio
 *
 * Coded by dubbeh - www.dubbeh.net
 *
 * Licensed under the GPLv3
 *
 */


void PrintPrimaryGenreList(int iClient)
{
	int iIndex = 0;
	int iCount = 0;
	char szGenreName[64] = "";
	char szBuffer[512] = "";
	
	for (iIndex = 0, iCount = 0; iIndex < g_Genres.iCount; iIndex++)
	{
		if (g_Genres.GetParentID(iIndex) == 0)
		{
			g_Genres.GetName(iIndex, szGenreName, sizeof(szGenreName));
			
			if ((iIndex + 2) == g_Genres.iCount)
			{
				StrCat(szBuffer, sizeof(szBuffer), szGenreName);
			}
			else
			{
				StrCat(szBuffer, sizeof(szBuffer), szGenreName);
				StrCat(szBuffer, sizeof(szBuffer), ", ");
			}
			
			iCount++;
			
			if (iCount == 10)
			{
				CReplyToCommand(iClient, szBuffer);
				clear_string(szBuffer, strlen(szBuffer));
				iCount = 0;
			}
		}
	}
	
	if (iCount < 10)
		CReplyToCommand(iClient, szBuffer);
}

void clear_string(char[] szBuffer, int iLen)
{
	int iIndex = 0;
	
	for (iIndex = 0; iIndex <= iLen; iIndex++)
		szBuffer[iIndex] = 0;
}

void BrowseURL(int iClient, char[] szURL)
{
	char szBuffer[MAX_MOTD_URL_SIZE + 1] = "";
	
	if (g_EngineVersion == Engine_CSGO) {
		// Does the string start with http?
		if (!strncmp(szURL, "http", 4, false)) {
			strcopy(szBuffer, MAX_MOTD_URL_SIZE, szURL);
		} else {
			Format(szBuffer, MAX_MOTD_URL_SIZE, "https://%s", szURL);
		}
		
		LoadMOTDPanel(iClient, "SourceMod Browse", szBuffer, false);
	} else {
		ShowMOTDPanel(iClient, "SourceMod Browse", szURL, MOTDPANEL_TYPE_URL);
	}
}

void LoadStation(int iClient, char[] szStationID, bool bCustomShoutCast)
{
	int iStationID = 0;
	int iStationIndex = 0;
	char szBuffer[MAX_MOTD_URL_SIZE] = "";
	char szStreamURL[128] = "";
	char szStationName[64] = "";
	char szURLBuffer[MAX_MOTD_URL_SIZE + 1];
	char szVolume[12] = "";
	
	if (((iStationID = StringToInt(szStationID)) > 0) && IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		if (g_iPlayType == RADIO_PLAY_TYPE_SHOUTCAST)
		{
			if (bCustomShoutCast)
			{
				iStationIndex = g_CustStations.GetIndexFromID(iStationID);
				if (g_CustStations.IsValid(iStationIndex))
				{
					g_CustStations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
					if (szStreamURL[0])
					{
						g_Cookies.GetVolume(iClient, szVolume, sizeof(szVolume));
						RadioVolumeWrapper(szBuffer, MAX_MOTD_URL_SIZE, iClient, szStreamURL, szVolume);
						ShowMOTDFromURL(iClient, szBuffer);
						SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
						
						if (g_cVarStationAdvert.IntValue)
						{
							g_CustStations.GetName(iStationIndex, szStationName, sizeof(szStationName));
							AdvertiseStationChoice(iClient, szStationName);
						}
					}
					else
					{
						RLogMessage(g_szNoStreamURLSet, g_CustStations.GetID(iStationIndex));
					}
				}
				else
				{
					RLogMessage(g_szInvalidStationIndex);
				}
			}
			else
			{
				iStationIndex = g_Stations.GetIndexFromID(iStationID);
				if (g_Stations.IsValid(iStationIndex))
				{
					g_Cookies.GetVolume(iClient, szVolume, sizeof(szVolume));
					Format(szBuffer, sizeof(szBuffer), "%s?sid=%d&mod=%d&vol=%s", g_szShoutCastURL, g_Stations.GetID(iStationIndex), g_EngineVersion, szVolume);
					ShowMOTDFromURL(iClient, szBuffer);
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				}
				else
				{
					RLogMessage(g_szInvalidStationIndex);
				}
			}
		}
		else if (g_iPlayType == RADIO_PLAY_TYPE_DIRECT)
		{
			iStationIndex = g_Stations.GetIndexFromID(iStationID);
			if (g_Stations.IsValid(iStationIndex))
			{
				g_Stations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
				if (szStreamURL[0])
				{
					ShowMOTDFromURL(iClient, szStreamURL);
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				}
				else
				{
					RLogMessage(g_szNoStreamURLSet, g_Stations.GetID(iStationIndex));
				}
			}
			else
			{
				RLogMessage(g_szInvalidStationIndex);
			}
		}
		else if (g_iPlayType == RADIO_PLAY_TYPE_VOLUME_CONTROL)
		{
			iStationIndex = g_Stations.GetIndexFromID(iStationID);
			if (g_Stations.IsValid(iStationIndex))
			{
				g_Stations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
				if (szStreamURL[0])
				{
					g_Cookies.GetVolume(iClient, szVolume, sizeof(szVolume));
					RadioVolumeWrapper(szURLBuffer, MAX_MOTD_URL_SIZE, iClient, szStreamURL, szVolume);
					ShowMOTDFromURL(iClient, szURLBuffer);
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				}
				else
				{
					RLogMessage(g_szNoStreamURLSet, g_Stations.GetID(iStationIndex));
				}
			}
			else
			{
				RLogMessage(g_szInvalidStationIndex);
			}
		}
	}
}

void SetClientCookiesForStation(int iClient, char[] szStationID, bool bIsCustom)
{
	char szPlayType[8] = "";
	
	g_Cookies.SetID(iClient, szStationID);
	
	if (bIsCustom)
		g_Cookies.SetIsCustom(iClient, "1");
	else
		g_Cookies.SetIsCustom(iClient, "0");
	
	IntToString(g_iPlayType, szPlayType, sizeof(szPlayType));
	g_Cookies.SetPlayType(iClient, szPlayType);
}

void AdvertiseStationChoice(int iClient, char[] szStationName)
{
	char szClientName[MAX_NAME_LENGTH + 1];
	
	GetClientName(iClient, szClientName, sizeof(szClientName));
	CPrintToChatAll("%T", "Started Listening", LANG_SERVER, szClientName, szStationName);
}

void ShowMOTDFromURL(int iClient, const char[] szURL)
{
	if (!IsClientConnected(iClient) || !IsClientInGame(iClient))
		return;
	
	if (g_EngineVersion == Engine_CSGO)
	    LoadMOTDPanel(iClient, PLUGIN_NAME, szURL, true);
	else
		LoadMOTDPanel(iClient, PLUGIN_NAME, szURL, false);
}

char RadioVolumeWrapper(char []szBuffer, int iBufferSize, int iClient, char[] szStationURL, char []szVolume)
{
	// Force JPlayer for Left 4 Dead 1 and 2
	if ((g_cVarVolumeWrapperType.IntValue == 0) && (g_EngineVersion != Engine_Left4Dead2 && g_EngineVersion != Engine_Left4Dead)) {
		Format(szBuffer, iBufferSize, "%s/html_rvw.html?url=%s&volume=%s", g_szVolumeWrappersBaseURL, szStationURL, szVolume);
	} else {
		Format(szBuffer, iBufferSize, "%s/jplayer_rvw.html?url=%s&volume=%s", g_szVolumeWrappersBaseURL, szStationURL, szVolume);
	}
	
	IsURLTooLong(iClient, szBuffer);
}

void IsURLTooLong(int iClient, char[] szURL)
{
	if (IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		if (strlen(szURL) > MAX_MOTD_URL_SIZE)
		{
			RLogMessage("[SM-RADIO] Warning: URL \"%s\" exceeds the 192 bytes limit and will end up truncated.", szURL);
			CPrintToChat(iClient, "%T", "Radio URL Too Long", LANG_SERVER);
		}
	}
}


void LoadOffPage(int iClient)
{
	char szClientName[MAX_NAME_LENGTH + 1] = "";
	
	if (IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		LoadMOTDPanel(iClient, PLUGIN_NAME, g_szRadioOffPage, true);
		
		g_Cookies.SetPlayType(iClient, "0");
		g_Cookies.SetID(iClient, "0");
		
		if (g_cVarStationAdvert.IntValue)
		{
			GetClientName(iClient, szClientName, sizeof(szClientName));
			CPrintToChatAll("%T", "Stopped Listening", LANG_SERVER, szClientName);
		}
	}
}

void LoadMOTDPanel(int iClient, const char[] szTitle, const char[] szPage, bool bHidden)
{
	if (!IsClientConnected(iClient) || !IsClientInGame(iClient))
		return;
	
	// If client has cl_disabledhtmlmotd on - Don't try to display an MOTD panel and load radio
	if (g_bDisabledHTMLMOTD[iClient]) {
		CPrintToChat(iClient, "%T", "Disabled HTML MOTD On", LANG_SERVER);
		return;
	}
	
	if (g_EngineVersion == Engine_CSGO)
	{
		if (g_bMOTDFAvail) {
			MOTDF_ShowMOTDPanel(iClient, szTitle, szPage, bHidden);
		} else {
			if (!g_cVarNoMissingMOTDFMsgs.BoolValue)
			    CPrintToChat(iClient, "%T", "MOTD Fixer Not Found", LANG_SERVER);
			ShowMOTDPanelCustom(iClient, szTitle, szPage, bHidden);
		}
	} else if (g_EngineVersion == Engine_Left4Dead2 || g_EngineVersion == Engine_Left4Dead) {
		ShowMOTDPanel(iClient, szTitle, szPage, MOTDPANEL_TYPE_URL);
	} else {
		ShowMOTDPanelCustom(iClient, szTitle, szPage, bHidden);
	}
}

void LoadStationFromCookie(int iClient)
{
	char szStationID[32] = "";
	int iStationID = 0;
	
	if (AreClientCookiesCached(iClient))
	{
		iStationID = g_Cookies.GetID(iClient);
		
		// Make sure we only load stations that are saved from the correct playtype
		// Check the playtype is correct and a Station ID is set aka. Station ID > 0
		if (g_iPlayType == g_Cookies.GetPlayType(iClient) && iStationID > 0)
		{
			// Is the station saved as ShoutCast Custom and custom playlists enabled?
			if (g_Cookies.GetIsCustom(iClient) && g_cVarShoutCastCustom.BoolValue)
			{
				IntToString(g_Cookies.GetID(iClient), szStationID, sizeof(szStationID));
				LoadStation(iClient, szStationID, true);
			}
			else
			{
				IntToString(g_Cookies.GetID(iClient), szStationID, sizeof(szStationID));
				LoadStation(iClient, szStationID, false);
			}
		}
	}
}

void RLogMessage (char []szInput, any ...)
{
	char szBuffer[1024] = "";
	
	if (g_cVarLogging.BoolValue) {
		VFormat(szBuffer, sizeof (szBuffer), szInput, 2);
		LogMessage(szBuffer);
	}
}

void ShowMOTDPanelCustom (int iClient, const char[] szTitle, const char[] szPage, bool bHidden)
{
	Handle kv = INVALID_HANDLE;
	kv = CreateKeyValues("data");
		
	KvSetString(kv, "title", szTitle);
	KvSetNum(kv, "type", MOTDPANEL_TYPE_URL);
	KvSetString(kv, "msg", szPage);
	KvSetNum(kv, "cmd", 0); //http://forums.alliedmods.net/showthread.php?p=1220212
	//KvSetNum(kv, "customsvr", 1); // Only for big panels in TF2 - Thanks Dr. McKay
	ShowVGUIPanel(iClient, "info", kv, bHidden);
	CloseHandle(kv);
}